class SemaphoreWeak implements Semaphore {
   private int count;

   public synchronized void up() {
     count = count + 1;
     notify();    // wake up a waiting thread
   }

   public synchronized void down() throws InterruptedException {
     while (count == 0)
       wait();   // suspend running thread
     count = count - 1; // now count > 0
   }

   public synchronized int count() {
     return count;
   }

   SemaphoreWeak(int capacity) {
     count = capacity;
   }
}
